## n2n 1.3.1~svn3789

=== Makefile ===

N2N_VERSION="1.3.2"

########

CC=gcc
DEBUG?=-g
WARN?=-Wall -Wshadow -Wpointer-arith -Wmissing-declarations -Wnested-externs

#Ultrasparc64 users experiencing SIGBUS should try the following gcc options
#(thanks to Robert Gibbon)
PLATOPTS_SPARC64=-mcpu=ultrasparc -pipe -fomit-frame-pointer -ffast-math -finline-functions -fweb -frename-registers -mapp-regs


CFLAGS+=$(DEBUG) $(WARN) $(OPTIONS) $(PLATOPTS)

INSTALL=install
MKDIR=mkdir -p

INSTALL_PROG=$(INSTALL) -m755
INSTALL_DOC=$(INSTALL) -m644


# DESTDIR set in debian make system
PREFIX?=$(DESTDIR)/usr
BINDIR=$(PREFIX)/bin
SBINDIR=$(PREFIX)/sbin
MANDIR?=$(PREFIX)/share/man
MAN1DIR=$(MANDIR)/man1
MAN8DIR=$(MANDIR)/man8

N2N_LIB=n2n.a
N2N_OBJS=n2n.o minilzo.o twofish.o tuntap_freebsd.o tuntap_linux.o tuntap_osx.o version.o
LIBS=-lpthread

APPS=edge supernode
DOCS=edge.8.gz supernode.1.gz

all: $(APPS) #$(DOCS)

edge: edge.c $(N2N_LIB) n2n.h Makefile
	$(CC) $(CFLAGS) edge.c $(N2N_LIB) $(LIBS) -o edge

supernode: supernode.c $(N2N_LIB) n2n.h Makefile
	$(CC) $(CFLAGS) supernode.c $(N2N_LIB) $(LIBS) -o supernode

.c.o: n2n.h Makefile
	$(CC) $(CFLAGS) -c $<

%.gz : %
	gzip -c $< > $@

$(N2N_LIB): $(N2N_OBJS)
	ar rcs $(N2N_LIB) $(N2N_OBJS)
#	$(RANLIB) $@

version.c:
	@echo $(N2N_VERSION) | sed -e 's/.*/const char * version   = "&";/' > version.c
	@uname -p | sed -e 's/.*/const char * osName    = "&";/' >> version.c
	@date +"%D %r" | sed -e 's/.*/const char * buildDate = "&";/' >> version.c

clean:
	rm -rf $(N2N_OBJS) $(N2N_LIB) $(APPS) $(DOCS) *.dSYM *~ version.c

install: edge supernode edge.8.gz supernode.1.gz
	echo "MANDIR=$(MANDIR)"
	$(MKDIR) $(BINDIR) $(SBINDIR) $(MAN1DIR) $(MAN8DIR)
	$(INSTALL_PROG) supernode $(BINDIR)/
	$(INSTALL_PROG) edge $(SBINDIR)/
	$(INSTALL_DOC) edge.8.gz $(MAN8DIR)/
	$(INSTALL_DOC) supernode.1.gz $(MAN1DIR)/

# Courtesy of Ole Tange <ole@tange.dk>

deb:
	dpkg-buildpackage

=== openwrt/kamikaze/Makefile ===
#
# Copyright (C) 2008 OpenWrt.org
#
# This is free software, licensed under the GNU General Public License v2.


include $(TOPDIR)/rules.mk

PKG_BRANCH:=trunk
PKG_SOURCE_URL:=https://svn.ntop.org/svn/ntop/trunk/n2n
PKG_REV:=$(shell LC_ALL=C svn info ${PKG_SOURCE_URL} | sed -ne's/^Last Changed Rev: //p')

PKG_NAME:=n2n
PKG_VERSION:=svn$(PKG_REV)
PKG_RELEASE:=1

PKG_SOURCE_SUBDIR:=$(PKG_NAME)-$(PKG_VERSION)
PKG_SOURCE:=$(PKG_SOURCE_SUBDIR).tar.gz
PKG_SOURCE_PROTO:=svn
PKG_SOURCE_VERSION:=$(PKG_REV)

PKG_BUILD_DEPENDS:=

PKG_BUILD_DIR:=$(BUILD_DIR)/$(PKG_NAME)-$(PKG_VERSION)
PKG_INSTALL_DIR:=$(PKG_BUILD_DIR)



include $(INCLUDE_DIR)/package.mk

define Package/n2n
  SECTION:=net
  CATEGORY:=Network
  TITLE:=VPN tunneling daemon
  URL:=http://www.ntop.org/n2n/
  SUBMENU:=VPN
  DEPENDS:=libpthread
endef


define Build/Configure
endef

define Build/Compile
	$(MAKE) CC="$(TARGET_CC)" -C $(PKG_BUILD_DIR)
endef


define Package/n2n/install
	$(INSTALL_DIR) $(1)/usr/sbin
	$(INSTALL_BIN) $(PKG_INSTALL_DIR)/edge $(1)/usr/sbin/
	$(INSTALL_BIN) $(PKG_INSTALL_DIR)/supernode $(1)/usr/sbin/
endef

$(eval $(call BuildPackage,n2n))

=== debian/changelog ===
n2n (1.3.1~svn3789-7) unstable; urgency=medium

  [ Rolf Leggewie ]
  * control:
    - add run-time depency on net-tools. Closes: #876386
    - use publicly accessible Vcs-Git URI
  * README: talk a bit about security implications of an abandoned upstream

  [ Chris Lamb ]
  * patches: Make the build reproducible. Closes: #833819

 -- Rolf Leggewie <foss@rolf.leggewie.biz>  Tue, 17 Apr 2018 15:52:27 +0800

n2n (1.3.1~svn3789-6) unstable; urgency=medium

  * control:
    - bump to Debian Standard 4.1.4
    - add run-time dependency on lsb-base
    - update git URIs
    - change priority from extra to optional
    - drop inactive co-maintainer
      Thank you for your work. Welcome back anytime!
  * copyright: update to 2018
  * default: change default supernode to bytemark.leggewie.org
  * init: merge two N2N_SUPERNODE* variables into one
  * README:
    - improve some botched wording
    - add information about two new public supernodes

 -- Rolf Leggewie <foss@rolf.leggewie.biz>  Sun, 15 Apr 2018 15:03:20 +0800

n2n (1.3.1~svn3789-5) unstable; urgency=medium

  * ship init script for controlling the n2n VPN. Closes: #742098
  * make the README more userfriendly and relevant to ordinary users
  * control: bump to Standard 3.9.6. No further changes.

 -- Rolf Leggewie <foss@rolf.leggewie.biz>  Sun, 26 Oct 2014 13:27:55 +0900

n2n (1.3.1~svn3789-4) unstable; urgency=low

  * move the updated package from experimental to unstable now
  * copyright: Update copyright information.
  * control: Update to policy 3.9.4. No further changes.

 -- Rolf Leggewie <foss@rolf.leggewie.biz>  Wed, 29 May 2013 17:55:10 +0800

n2n (1.3.1~svn3789-3) experimental; urgency=low

  * update build process from dh7 to dh9
  * backport upstream-svn4235.patch to fix compile error
  * patch Makefile to import $LDFLAGS and $CPPFLAGS into $CFLAGS

 -- Rolf Leggewie <foss@rolf.leggewie.biz>  Fri, 28 Dec 2012 03:09:08 +0100

n2n (1.3.1~svn3789-2) experimental; urgency=low

  * debian/control:
    - add myself to Uploaders
    - add ${misc:Depends} to run-time dependencies
    - add Homepage and VCS fields
    - bump standards version to 3.9.3 (no further changes)
  * debian/rules: radically simplify and rely on dh7 build intelligence
  * debian/source/format: use DebSrc3 format
  * debian/README.Debian: add information about public supernode

 -- Rolf Leggewie <foss@rolf.leggewie.biz>  Fri, 14 Dec 2012 13:01:40 +0100

n2n (1.3.1~svn3789-1) unstable; urgency=low

  * Update package to version 1.3 from upstream cvs
  * Removed "libc6-dev (>= 2.0)" build dependency (closes: Bug#533881)
  * DH compatibility level is 7
  * Run dh_prep instead of dh_clean -k
  * Standards Version is 3.8.2

 -- cristian paul peñaranda rojas <kristian.paul@gmail.com>  Sun, 22 Jun 2009 21:19:58 -0500

n2n (1.2.2~svn3653) unstable; urgency=low

  * Initial release (closes: Bug#507750)

 -- cristian paul peñaranda rojas <kristian.paul@gmail.com>  Sat, 29 Nov 2008 00:31:58 -0500

=== debian/control ===
Source: n2n
Section: net
Priority: optional
Maintainer: Rolf Leggewie <foss@rolf.leggewie.biz>
Build-Depends: debhelper (>= 9)
Standards-Version: 4.1.4
Homepage: http://www.ntop.org/products/n2n/
Vcs-Browser: https://github.com/leggewie-DM/n2n
Vcs-Git: https://github.com/leggewie-DM/n2n.git

Package: n2n
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends},
 lsb-base (>= 3.0-6), net-tools
Description: Peer-to-Peer VPN network daemon
 n2n is an open source VPN application which utilizes 
 a Peer-to-peer architecture for network membership 
 and routing.

## n2n 2.1.0-2maemo0

=== Makefile ===

N2N_VERSION=2.1.0
N2N_OSNAME=$(shell uname -p)

########

CC=gcc
DEBUG?=-g3
#OPTIMIZATION?=-O2
WARN?=-Wall -Wshadow -Wpointer-arith -Wmissing-declarations -Wnested-externs

#Ultrasparc64 users experiencing SIGBUS should try the following gcc options
#(thanks to Robert Gibbon)
PLATOPTS_SPARC64=-mcpu=ultrasparc -pipe -fomit-frame-pointer -ffast-math -finline-functions -fweb -frename-registers -mapp-regs

N2N_DEFINES=
N2N_OBJS_OPT=
LIBS_EDGE_OPT=

N2N_OPTION_AES?="yes"
#N2N_OPTION_AES=no

ifeq ($(N2N_OPTION_AES), "yes")
    N2N_DEFINES+="-DN2N_HAVE_AES"
    LIBS_EDGE_OPT+=-lcrypto
endif

CFLAGS+=$(DEBUG) $(OPTIMIZATION) $(WARN) $(OPTIONS) $(PLATOPTS) $(N2N_DEFINES)

INSTALL=install
MKDIR=mkdir -p

INSTALL_PROG=$(INSTALL) -m755
INSTALL_DOC=$(INSTALL) -m644


# DESTDIR set in debian make system
PREFIX?=$(DESTDIR)/usr
#BINDIR=$(PREFIX)/bin
SBINDIR=$(PREFIX)/sbin
MANDIR?=$(PREFIX)/share/man
MAN1DIR=$(MANDIR)/man1
MAN7DIR=$(MANDIR)/man7
MAN8DIR=$(MANDIR)/man8

N2N_LIB=n2n.a
N2N_OBJS=n2n.o n2n_keyfile.o wire.o minilzo.o twofish.o \
         transform_null.o transform_tf.o transform_aes.o \
         tuntap_freebsd.o tuntap_netbsd.o tuntap_linux.o tuntap_osx.o version.o
LIBS_EDGE+=$(LIBS_EDGE_OPT)
LIBS_SN=

#For OpenSolaris (Solaris too?)
ifeq ($(shell uname), SunOS)
LIBS_EDGE+=-lsocket -lnsl
LIBS_SN+=-lsocket -lnsl
endif

APPS=edge
APPS+=supernode

DOCS=edge.8.gz supernode.1.gz n2n_v2.7.gz

all: $(APPS) $(DOCS)

edge: edge.c $(N2N_LIB) n2n_wire.h n2n.h Makefile
	$(CC) $(CFLAGS) edge.c $(N2N_LIB) $(LIBS_EDGE) -o edge

test: test.c $(N2N_LIB) n2n_wire.h n2n.h Makefile
	$(CC) $(CFLAGS) test.c $(N2N_LIB) $(LIBS_EDGE) -o test

supernode: sn.c $(N2N_LIB) n2n.h Makefile
	$(CC) $(CFLAGS) sn.c $(N2N_LIB) $(LIBS_SN) -o supernode

benchmark: benchmark.c $(N2N_LIB) n2n_wire.h n2n.h Makefile
	$(CC) $(CFLAGS) benchmark.c $(N2N_LIB) $(LIBS_SN) -o benchmark

.c.o: n2n.h n2n_keyfile.h n2n_transforms.h n2n_wire.h twofish.h Makefile
	$(CC) $(CFLAGS) -c $<

%.gz : %
	gzip -c $< > $@

$(N2N_LIB): $(N2N_OBJS)
	ar rcs $(N2N_LIB) $(N2N_OBJS)
#	$(RANLIB) $@

version.o: Makefile
	$(CC) $(CFLAGS) -DN2N_VERSION='"$(N2N_VERSION)"' -DN2N_OSNAME='"$(N2N_OSNAME)"' -c version.c

clean:
	rm -rf $(N2N_OBJS) $(N2N_LIB) $(APPS) $(DOCS) test *.dSYM *~

install: edge supernode edge.8.gz supernode.1.gz n2n_v2.7.gz
	echo "MANDIR=$(MANDIR)"
	$(MKDIR) $(SBINDIR) $(MAN1DIR) $(MAN7DIR) $(MAN8DIR)
	$(INSTALL_PROG) supernode $(SBINDIR)/
	$(INSTALL_PROG) edge $(SBINDIR)/
	$(INSTALL_DOC) edge.8.gz $(MAN8DIR)/
	$(INSTALL_DOC) supernode.1.gz $(MAN1DIR)/
	$(INSTALL_DOC) n2n_v2.7.gz $(MAN7DIR)/

=== win32/CMakeLists.txt ===
add_library(n2n_win32
            win32/getopt1.c
            win32/getopt.c
            win32/wintap.c)

=== debian/changelog ===
n2n (2.1.0-2maemo0) lucid; urgency=low

  * Give it a try ...

 -- COLIN Stephane <colin.stephane@ovi.com>  Thu,  6 Dec 2012 22:31:17 +0100

n2n (2.1.0-2~webupd8~lucid1) lucid; urgency=low

  * proper packaging (separated debian folder)

 -- Alin Andrei <webupd8@gmail.com>  Mon, 11 Oct 2010 14:04:32 +0300

n2n (2.1.0-2~webupd8~maverick) maverick; urgency=low

  * Split package in two.
  * Move manpage for edge to section 8.
  * Install manpage for n2n_v2 to section 7.
  * Create init.d files for the daemons.

 -- Alin Andrei <webupd8@gmail.com>  Sun, 04 Apr 2010 21:40:46 +0200

n2n (2.1.0-1) unstable; urgency=low

  * Split package in two.
  * Move manpage for edge to section 8.
  * Install manpage for n2n_v2 to section 7.
  * Create init.d files for the daemons.

 -- Kim Hansen <kim@i9.dk>  Sun, 04 Apr 2010 21:40:46 +0200

n2n (2.0-1) hardy; urgency=low

  * New upstream release

 -- Richard Andrews <andrews@ntop.org>  Tue, 30 Oct 2009 22:26:04 +1100

n2n (1.3-1) hardy; urgency=low

  * New upstream release

 -- Richard Andrews <andrews@ntop.org>  Fri, 30 Jan 2009 23:49:56 +1100

n2n (1.2-1) unstable; urgency=low

  * Initial release

 -- Richard Andrews <andrews@ntop.org>  Thu, 10 Jul 2008 22:38:02 +1000

=== debian/control ===
Source: n2n
Section: net
Priority: extra
Maintainer: Jean-Baptiste Denis <jeanbaptiste.denis@gmail.com>
Build-Depends: cdbs, debhelper (>= 5), libc6-dev (>= 2.0), dpatch, gcc, libssl-dev
Standards-Version: 3.7.2

Package: n2n
Architecture: any
Depends: n2n-edge, n2n-supernode
Description: dummy package for transition purposes
 A dummy package for transition purposes that depends on n2n-edge and
 n2n-supernode

Package: n2n-edge
Architecture: any
Suggests: uml-utilities
Depends: ${shlibs:Depends}, ${misc:Depends}
Conflicts: n2n (<< 2.1.0-1)
Replaces: n2n (<< 2.1.0-1)
Description: a layer-two peer-to-peer virtual private network (VPN)
 n2n is a layer-two peer-to-peer virtual private network (VPN) which allows
 users to exploit features typical of P2P applications at network instead of
 application level. This means that users can gain native IP visibility (e.g.
 two PCs belonging to the same n2n network can ping each other) and be
 reachable with the same network IP address regardless of the network where
 they currently belong. In a nutshell, as OpenVPN moved SSL from application
 (e.g. used to implement the https protocol) to network protocol, n2n moves
 P2P from application to network level.
 .
 Edge is the edge node daemon for n2n which creates a TAP interface to expose
 the n2n virtual LAN.

Package: n2n-supernode
Architecture: any
Suggests: n2n-edge
Depends: ${shlibs:Depends}, ${misc:Depends}
Conflicts: n2n (<< 2.1.0-1)
Replaces: n2n (<< 2.1.0-1)
Description: a layer-two peer-to-peer virtual private network (VPN)
 n2n is a layer-two peer-to-peer virtual private network (VPN) which allows
 users to exploit features typical of P2P applications at network instead of
 application level. This means that users can gain native IP visibility (e.g.
 two PCs belonging to the same n2n network can ping each other) and be
 reachable with the same network IP address regardless of the network where
 they currently belong. In a nutshell, as OpenVPN moved SSL from application
 (e.g. used to implement the https protocol) to network protocol, n2n moves
 P2P from application to network level.
 .
 Supernode is a node introduction registry, broadcast conduit and packet relay
 node for the n2n system.

=== debian/rules ===
#!/usr/bin/make -f
  
include /usr/share/cdbs/1/rules/debhelper.mk
include /usr/share/cdbs/1/class/makefile.mk

## n2n v2-9349

=== CMakeLists.txt ===
project(n2n)
cmake_minimum_required(VERSION 2.6)

# N2n information
set(N2N_VERSION 2.1.0)
set(N2N_OSNAME ${CMAKE_SYSTEM})

# N2n specific params
if(NOT DEFINED N2N_OPTION_AES)
set(N2N_OPTION_AES ON)
endif(NOT DEFINED N2N_OPTION_AES)

add_definitions(-DN2N_VERSION='\"${N2N_VERSION}\"' -DN2N_OSNAME='\"${N2N_OSNAME}\"')

if(N2N_OPTION_AES)
add_definitions(-DN2N_HAVE_AES)
endif(N2N_OPTION_AES)

# Build information
if(NOT DEFINED BUILD_SHARED_LIBS)
set(BUILD_SHARED_LIBS OFF)
endif(NOT DEFINED BUILD_SHARED_LIBS)

if(NOT DEFINED CMAKE_BUILD_TYPE)
set(CMAKE_BUILD_TYPE None)
endif(NOT DEFINED CMAKE_BUILD_TYPE)
#set(CMAKE_BUILD_TYPE Debug)
#set(CMAKE_BUILD_TYPE Release)

#Ultrasparc64 users experiencing SIGBUS should try the following gcc options
#(thanks to Robert Gibbon) 
#PLATOPTS_SPARC64=-mcpu=ultrasparc -pipe -fomit-frame-pointer -ffast-math -finline-functions -fweb -frename-registers -mapp-regs

# None
set(CMAKE_C_FLAGS "-Wall -Wshadow -Wpointer-arith -Wmissing-declarations -Wnested-externs")
set(CMAKE_CXX_FLAGS "-Wall -Wshadow -Wpointer-arith -Wmissing-declarations -Wnested-externs")
# Debug 
set(CMAKE_C_FLAGS_DEBUG "-g")
set(CMAKE_CXX_FLAGS_DEBUG "-g")
# Release
set(CMAKE_C_FLAGS_RELEASE "-O2 -DNDEBUG")
set(CMAKE_CXX_FLAGS_RELEASE "-O2 -DNDEBUG")

## DEBUG FOR CMAKE
#message(${N2N_VERSION}) 
#message(${N2N_OSNAME})
##message(${CMAKE_BUILD_TYPE})
#message(${N2N_OPTION_AES})
## DEBUG FOR CMAKE

add_library(n2n n2n.c
                n2n_keyfile.c
                wire.c
                minilzo.c
                twofish.c
                transform_null.c
                transform_tf.c
                transform_aes.c
                tuntap_freebsd.c
                tuntap_netbsd.c
                tuntap_linux.c
                tuntap_osx.c
                version.c
            )

if(DEFINED WIN32)
add_subdirectory(win32)
target_link_libraries(n2n n2n_win32)
endif(DEFINED WIN32)

if(N2N_OPTION_AES)
target_link_libraries(n2n crypto)
endif(N2N_OPTION_AES)

# For Solaris (or OpenSolaris?)
#target_link_libraries(n2n socket nsl)

add_executable(edge edge.c)
target_link_libraries(edge n2n)

add_executable(supernode sn.c)
target_link_libraries(supernode n2n)

add_executable(test test.c)
target_link_libraries(test n2n)

add_executable(benchmark benchmark.c)
target_link_libraries(benchmark n2n)

install(TARGETS edge supernode
        RUNTIME DESTINATION sbin
        LIBRARY DESTINATION lib
        ARCHIVE DESTINATION lib
       )

# Documentation
if(DEFINED UNIX)
add_dependencies(n2n doc)
file(MAKE_DIRECTORY ${PROJECT_BINARY_DIR}/doc)
add_custom_command(OUTPUT ${PROJECT_BINARY_DIR}/doc/edge.8.gz
                   COMMAND gzip -c ${PROJECT_SOURCE_DIR}/edge.8 > ${PROJECT_BINARY_DIR}/doc/edge.8.gz
                   DEPENDS ${PROJECT_SOURCE_DIR}/edge.8
                  )

add_custom_command(OUTPUT ${PROJECT_BINARY_DIR}/doc/supernode.1.gz
                   COMMAND gzip -c ${PROJECT_SOURCE_DIR}/supernode.1 > ${PROJECT_BINARY_DIR}/doc/supernode.1.gz
                   DEPENDS ${PROJECT_SOURCE_DIR}/supernode.1
                  )

add_custom_command(OUTPUT ${PROJECT_BINARY_DIR}/doc/n2n_v2.7.gz
                   COMMAND gzip -c ${PROJECT_SOURCE_DIR}/n2n_v2.7 > ${PROJECT_BINARY_DIR}/doc/n2n_v2.7.gz
                   DEPENDS ${PROJECT_SOURCE_DIR}/n2n_v2.7
                  )

add_custom_target(doc DEPENDS ${PROJECT_BINARY_DIR}/doc/edge.8.gz
                              ${PROJECT_BINARY_DIR}/doc/supernode.1.gz
                              ${PROJECT_BINARY_DIR}/doc/n2n_v2.7.gz
                 )

set_source_files_properties(${PROJECT_BINARY_DIR}/doc/edge.8.gz
                            ${PROJECT_BINARY_DIR}/doc/supernode.1.gz
                            ${PROJECT_BINARY_DIR}/doc/n2n_v2.7.gz
                            PROPERTIES GENERATED 1)

install(FILES ${PROJECT_BINARY_DIR}/doc/edge.8.gz
        DESTINATION /usr/share/man8)
install(FILES ${PROJECT_BINARY_DIR}/doc/supernode.1.gz
        DESTINATION /usr/share/man1)
install(FILES ${PROJECT_BINARY_DIR}/doc/n2n_v2.7.gz
        DESTINATION /usr/share/man7)
endif(DEFINED UNIX)

## n2n v2-master

=== CMakeLists.txt ===
--- 
+++ 
@@ -2,7 +2,7 @@
 cmake_minimum_required(VERSION 2.6)
 
 # N2n information
-set(N2N_VERSION 2.1.0)
+set(N2N_VERSION 2.3.0)
 set(N2N_OSNAME ${CMAKE_SYSTEM})
 
 # N2n specific params
@@ -10,9 +10,10 @@
 set(N2N_OPTION_AES ON)
 endif(NOT DEFINED N2N_OPTION_AES)
 
-add_definitions(-DN2N_VERSION='\"${N2N_VERSION}\"' -DN2N_OSNAME='\"${N2N_OSNAME}\"')
+add_definitions(-DN2N_VERSION="${N2N_VERSION}" -DN2N_OSNAME="${N2N_OSNAME}")
 
 if(N2N_OPTION_AES)
+find_package(OpenSSL REQUIRED)
 add_definitions(-DN2N_HAVE_AES)
 endif(N2N_OPTION_AES)
 
@@ -26,10 +27,6 @@
 endif(NOT DEFINED CMAKE_BUILD_TYPE)
 #set(CMAKE_BUILD_TYPE Debug)
 #set(CMAKE_BUILD_TYPE Release)
-
-#Ultrasparc64 users experiencing SIGBUS should try the following gcc options
-#(thanks to Robert Gibbon) 
-#PLATOPTS_SPARC64=-mcpu=ultrasparc -pipe -fomit-frame-pointer -ffast-math -finline-functions -fweb -frename-registers -mapp-regs
 
 # None
 set(CMAKE_C_FLAGS "-Wall -Wshadow -Wpointer-arith -Wmissing-declarations -Wnested-externs")
@@ -50,6 +47,7 @@
 
 add_library(n2n n2n.c
                 n2n_keyfile.c
+		edge_utils.c
                 wire.c
                 minilzo.c
                 twofish.c
@@ -71,9 +69,6 @@
 if(N2N_OPTION_AES)
 target_link_libraries(n2n crypto)
 endif(N2N_OPTION_AES)
-
-# For Solaris (or OpenSolaris?)
-#target_link_libraries(n2n socket nsl)
 
 add_executable(edge edge.c)
 target_link_libraries(edge n2n)

=== Makefile ===
--- 
+++ 
@@ -1,5 +1,5 @@
 
-N2N_VERSION=2.1.0
+N2N_VERSION=2.3.0
 N2N_OSNAME=$(shell uname -p)
 
 ########
@@ -21,7 +21,7 @@
 #N2N_OPTION_AES=no
 
 ifeq ($(N2N_OPTION_AES), "yes")
-    N2N_DEFINES+="-DN2N_HAVE_AES"
+    N2N_DEFINES+=-DN2N_HAVE_AES
     LIBS_EDGE_OPT+=-lcrypto
 endif
 
@@ -43,10 +43,12 @@
 MAN7DIR=$(MANDIR)/man7
 MAN8DIR=$(MANDIR)/man8
 
-N2N_LIB=n2n.a
+N2N_LIB=libn2n.a
 N2N_OBJS=n2n.o n2n_keyfile.o wire.o minilzo.o twofish.o \
+	 edge_utils.o \
          transform_null.o transform_tf.o transform_aes.o \
-         tuntap_freebsd.o tuntap_netbsd.o tuntap_linux.o tuntap_osx.o version.o
+         tuntap_freebsd.o tuntap_netbsd.o tuntap_linux.o \
+	 tuntap_osx.o version.o
 LIBS_EDGE+=$(LIBS_EDGE_OPT)
 LIBS_SN=
 
@@ -58,10 +60,11 @@
 
 APPS=edge
 APPS+=supernode
+APPS+=example_edge_embed
 
-DOCS=edge.8.gz supernode.1.gz n2n_v2.7.gz
+DOCS=edge.8.gz supernode.1.gz n2n.7.gz
 
-all: $(APPS) $(DOCS)
+all: $(APPS) $(DOCS) benchmark
 
 edge: edge.c $(N2N_LIB) n2n_wire.h n2n.h Makefile
 	$(CC) $(CFLAGS) edge.c $(N2N_LIB) $(LIBS_EDGE) -o edge
@@ -74,6 +77,9 @@
 
 benchmark: benchmark.c $(N2N_LIB) n2n_wire.h n2n.h Makefile
 	$(CC) $(CFLAGS) benchmark.c $(N2N_LIB) $(LIBS_SN) -o benchmark
+
+example_edge_embed: example_edge_embed.c $(N2N_LIB) n2n.h
+	$(CC) $(CFLAGS) example_edge_embed.c $(N2N_LIB) $(LIBS_EDGE) -o example_edge_embed
 
 .c.o: n2n.h n2n_keyfile.h n2n_transforms.h n2n_wire.h twofish.h Makefile
 	$(CC) $(CFLAGS) -c $<
@@ -91,11 +97,11 @@
 clean:
 	rm -rf $(N2N_OBJS) $(N2N_LIB) $(APPS) $(DOCS) test *.dSYM *~
 
-install: edge supernode edge.8.gz supernode.1.gz n2n_v2.7.gz
+install: edge supernode edge.8.gz supernode.1.gz n2n.7.gz
 	echo "MANDIR=$(MANDIR)"
 	$(MKDIR) $(SBINDIR) $(MAN1DIR) $(MAN7DIR) $(MAN8DIR)
 	$(INSTALL_PROG) supernode $(SBINDIR)/
 	$(INSTALL_PROG) edge $(SBINDIR)/
 	$(INSTALL_DOC) edge.8.gz $(MAN8DIR)/
 	$(INSTALL_DOC) supernode.1.gz $(MAN1DIR)/
-	$(INSTALL_DOC) n2n_v2.7.gz $(MAN7DIR)/
+	$(INSTALL_DOC) n2n.7.gz $(MAN7DIR)/

=== packages/debian/Makefile ===
#
# Change it according to your setup
#
N2N_HOME=$(PWD)/../..
N2N_BUILD=${N2N_HOME}/packages/debian/n2n

all: clean pkg

pkg:
	cd ../..; make; cd -
	if test -e "${N2N_BUILD}"; then /bin/rm -fr ${N2N_BUILD}; fi
	mkdir -p ${N2N_BUILD}/usr/sbin ${N2N_BUILD}/usr/share/man/man1 ${N2N_BUILD}/usr/share/man/man7 ${N2N_BUILD}/usr/share/man/man8
	install -m755 ../../supernode ${N2N_BUILD}/usr/sbin/
	install -m755 ../../edge ${N2N_BUILD}/usr/sbin/
	install -m644 ../../edge.8.gz ${N2N_BUILD}/usr/share/man/man8/
	install -m644 ../../supernode.1.gz ${N2N_BUILD}/usr/share/man/man1/
	install -m644 ../../n2n.7.gz ${N2N_BUILD}/usr/share/man/man7/
	@/bin/rm -f ../n2n*.deb
	dpkg-buildpackage -rfakeroot -d -us -uc
	#dpkg-sig --sign builder -k D1EB60BE ../n2n_*deb
	@\rm -f ../n2n_*dsc ../n2n_*.gz ../n2n_*changes
	@/bin/mv ../n2n_*deb .
	@echo
	@echo "Package built."
	@/bin/ls n2n_*deb
	@echo "-------------------------------"
	-dpkg -I n2n_*deb
	-dpkg --contents n2n_*deb
	@echo "-------------------------------"

distclean:
	echo "dummy distclean"

install:
	echo "dummy install"

clean:
	rm -rf *~ *deb

=== android/Hin2n/app/CMakeLists.txt ===
project(Hin2n)
cmake_minimum_required(VERSION 3.4.1)

# N2n information
set(N2N_VERSION 2.1.0)
set(N2N_OSNAME ${CMAKE_SYSTEM})

INCLUDE(TestBigEndian)
TEST_BIG_ENDIAN(UIP_CONF_BYTE_ORDER)
if(${UIP_CONF_BYTE_ORDER} EQUAL 1)
set(UIP_CONF_BYTE_ORDER UIP_BIG_ENDIAN)
else(${UIP_CONF_BYTE_ORDER} EQUAL 1)
set(UIP_CONF_BYTE_ORDER UIP_LITTLE_ENDIAN)
endif(${UIP_CONF_BYTE_ORDER} EQUAL 1)


if(CMAKE_BUILD_TYPE)
if(NOT ${CMAKE_BUILD_TYPE} STREQUAL Debug)
set(CMAKE_BUILD_TYPE Release)
endif(NOT ${CMAKE_BUILD_TYPE} STREQUAL Debug)
else(CMAKE_BUILD_TYPE)
set(CMAKE_BUILD_TYPE Release)
endif(CMAKE_BUILD_TYPE)


add_definitions(-DN2N_VERSION=\"${N2N_VERSION}\" -DN2N_OSNAME=\"${N2N_OSNAME}\" -DUIP_CONF_BYTE_ORDER=\"${UIP_CONF_BYTE_ORDER}\")
include_directories(src/main/cpp src/main/cpp/tun2tap src/main/cpp/uip)

add_library(edge SHARED
                src/main/cpp/n2n/android/edge_jni.c
                src/main/cpp/n2n/android/edge_android.c
            )
target_link_libraries(edge n2n)
target_link_libraries(edge log)

add_library(n2n SHARED
                src/main/cpp/n2n/n2n.c
                src/main/cpp/n2n/n2n_keyfile.c
                src/main/cpp/n2n/wire.c
                src/main/cpp/n2n/minilzo.c
                src/main/cpp/n2n/twofish.c
                src/main/cpp/n2n/edge_utils.c
                src/main/cpp/n2n/transform_null.c
                src/main/cpp/n2n/transform_tf.c
                src/main/cpp/n2n/transform_aes.c
                src/main/cpp/n2n/android/tuntap_android.c
                src/main/cpp/n2n/version.c
            )
target_link_libraries(n2n uip)
target_link_libraries(n2n log)

add_library(uip SHARED
                src/main/cpp/uip/uip.c
                src/main/cpp/uip/uip_arp.c
                src/main/cpp/tun2tap/tun2tap.c
            )
